#############################################################
#
# iproute2
#
#############################################################


IPROUTE2_VERSION=2.6.9
IPROUTE2_DIR=$(BUILD_DIR)/iproute2-$(IPROUTE2_VERSION)
IPROUTE2_SOURCE_URL=http://developer.osdl.org/dev/iproute2/download/
IPROUTE2_SOURCE=iproute2-2.6.9-ss040831.tar.gz

IPROUTE2_PATCH_DIR=$(PATCH_DIR)/iproute2
IPROUTE2_PATCH:=Makefile.diff

IPROUTE2_PKG_DIR=$(PACKAGES_DIR)/iproute2

$(DL_DIR)/$(IPROUTE2_SOURCE):
	 $(WGET) -P $(DL_DIR) $(IPROUTE2_SOURCE_URL)$(IPROUTE2_SOURCE)

$(IPROUTE2_DIR)/.unpacked: $(DL_DIR)/$(IPROUTE2_SOURCE)
	-rm -rf $(IPROUTE2_DIR).orig $(IPROUTE2_DIR)
	zcat $(DL_DIR)/$(IPROUTE2_SOURCE) | tar -C $(BUILD_DIR) -xvf -
	cat $(IPROUTE2_PATCH_DIR)/$(IPROUTE2_PATCH) | patch -p1 -d $(IPROUTE2_DIR)
	mkdir -p $(IPROUTE2_PKG_DIR)
	touch $(IPROUTE2_DIR)/.unpacked

$(IPROUTE2_DIR)/.configured: $(IPROUTE2_DIR)/.unpacked
	$(SED) "s,-I/usr/include/db3,," $(IPROUTE2_DIR)/Makefile
	$(SED) "s/rtacct arpd/rtacct/;" $(IPROUTE2_DIR)/misc/Makefile
	$(SED) "s/\$\(ARPDOBJ\)//;" $(IPROUTE2_DIR)/misc/Makefile
	touch  $(IPROUTE2_DIR)/.configured

$(IPROUTE2_DIR)/tc/tc: $(IPROUTE2_DIR)/.configured
	$(MAKE) -C $(IPROUTE2_DIR) \
		KERNEL_INCLUDE=$(LINUX_DIR)/include \
		DESTDIR=$(IPROUTE2_PKG_DIR) \
		CCOPTS="-D_GNU_SOURCE -Os -Wstrict-prototypes -Wall"

$(IPROUTE2_PKG_DIR)/sbin/ss: $(IPROUTE2_DIR)/tc/tc
	$(MAKE) -C $(IPROUTE2_DIR) \
		KERNEL_INCLUDE=$(LINUX_DIR)/include \
		DESTDIR=$(IPROUTE2_PKG_DIR) \
		SBINDIR=/sbin \
		LIBDIR=/lib \
		DOCDIR=/tmp \
		MANDIR=/tmp \
		CCOPTS="-D_GNU_SOURCE -Os -pipe" \
		install
	-$(SSTRIP) $(IPROUTE2_PKG_DIR)/sbin/*
	-rm -rf $(IPROUTE2_PKG_DIR)/tmp
	mv $(IPROUTE2_PKG_DIR)/sbin/ip $(ADD_MASTER)/sbin/.
	mv $(IPROUTE2_PKG_DIR)/sbin/tc $(ADD_MASTER)/sbin/.
	-rm $(ADD_MASTER)/etc/iproute2/*
	mkdir -p $(ADD_MASTER)/etc/iproute2
	-mv $(IPROUTE2_PKG_DIR)/etc/iproute2/* $(ADD_MASTER)/etc/iproute2/.

iproute2: $(IPROUTE2_PKG_DIR)/sbin/ss

iproute2-clean:
	-$(MAKE) -C $(IPROUTE2_DIR) clean
	rm -rf $(IPROUTE2_PKG_DIR)

iproute2-dirclean:
	rm -rf $(IPROUTE2_DIR)
	rm -rf $(IPROUTE2_PKG_DIR)

